//Vpis 12.4 Petovn konstruktor v odvozench tdch

#include <iostream>
using namespace std;

enum RASA { ZLATY_RETRIEVER, PUDL, JEZEVCIK, OVCAK, DOBRMAN, LABRADOR };

class Savec
{
public:
    // Konstruktory
    Savec();
    Savec(int vek);
    ~Savec();

    // Pstupov metody
    int ZjistitVek() const { return jehoVek; }
    void ZadatVek(int vek) { jehoVek = vek; }
    int ZjistitVahu() const { return jehoVaha; }
    void ZadatVahu(int vaha) { jehoVaha = vaha; }

    // Dal metody
    void Promluvit() const { cout << "Zvuk savce!\n"; }
    void Spat() const { cout << "Psssst. Prave spim.\n"; }


protected:
    int jehoVek;
    int jehoVaha;
};

class Pes : public Savec
{
public:

    // Konstruktory
    Pes();
    Pes(int vek);
    Pes(int vek, int vaha);
    Pes(int vek, RASA rasa);
    Pes(int vek, int vaha, RASA rasa);
    ~Pes();

    // Pstupov metody
    RASA ZjistitRasu() const { return jehoRasa; }
    void ZadatRasu(RASA rasa) { jehoRasa = rasa; }

    // Dal metody
    void VrtetOcasem() const { cout << "Vrti ocasem...\n"; }
    void PrositOJidlo() const { cout << "Prosi o jidlo...\n"; }

private:
    RASA jehoRasa;
};

Savec::Savec():
jehoVek(1),
jehoVaha(5)
{
    cout << "Konstruktor Savec...\n";
}

Savec::Savec(int vek):
jehoVek(vek),
jehoVaha(5)
{
    cout << "Konstruktor Savec(int)...\n";
}

Savec::~Savec()
{
    cout << "Destruktor Savec...\n";
}

Pes::Pes():
Savec(),
jehoRasa(ZLATY_RETRIEVER)
{
    cout << "Konstruktor Pes...\n";
}

Pes::Pes(int vek):
Savec(vek),
jehoRasa(ZLATY_RETRIEVER)
{
    cout << "Konstruktor Pes(int)...\n";
}

Pes::Pes(int vek, int vaha):
Savec(vek),
jehoRasa(ZLATY_RETRIEVER)
{
    jehoVaha = vaha;
    cout << "Konstruktor Pes(int, int)...\n";
}

Pes::Pes(int vek, int vaha, RASA rasa):
Savec(vek),
jehoRasa(rasa)
{
    jehoVaha = vaha;
    cout << "Konstruktor Pes(int, int, RASA)...\n";
}

Pes::Pes(int vek, RASA rasa):
Savec(vek),
jehoRasa(rasa)
{
    cout << "Konstruktor Pes(int, RASA)...\n";
}

Pes::~Pes()
{
    cout << "Destruktor Pes...\n";
}
int main()
{
    Pes fido;
    Pes punta(5);
    Pes bastr(6,8);
    Pes lassie(3,ZLATY_RETRIEVER);
    Pes hasky(4,20,DOBRMAN);
    fido.Promluvit();
    punta.VrtetOcasem();
    cout << "Lassie je " << lassie.ZjistitVek() << " let\n";
    cout << "Hasky vazi ";
    cout << hasky.ZjistitVahu() << " kilogramu\n";
    return 0;
}
