//Vpis 13.12 Pouit tdy Retezec

#include <iostream>
#include <string.h>
using namespace std;

// Zkladn etzcov tda
class Retezec
{
public:
	// Konstruktory
	Retezec();
	Retezec(const char *const);
	Retezec(const Retezec &);
	~Retezec();

	// Peten opertory
	char & operator[](unsigned short odsazeni);
	char operator[](unsigned short odsazeni) const;
	Retezec operator+(const Retezec&);
	void operator+=(const Retezec&);
	Retezec & operator= (const Retezec &);

	// Obecn pstupov funkce
	unsigned short PrevzitDelku()const { return jehoDelka; }
	const char * PrevzitRetezec() const { return jehoRetezec; }

private:
	Retezec (unsigned short);         // Soukrom konstruktor
	char * jehoRetezec;
	unsigned short jehoDelka;
};

// Vchoz konstruktor vytv etzec o dlce 0 bajt
Retezec::Retezec()
{
	jehoRetezec = new char[1];
	jehoRetezec[0] = '\0';
	jehoDelka=0;
}

// Soukrom (pomocn) konstruktor pouvan pouze
// metodami tdy k vytvoen novho etzce
// poadovan velikosti. Naplnn nulami.
Retezec::Retezec(unsigned short len)
{
	jehoRetezec = new char[len+1];
	for (unsigned short i = 0; i<=len; i++)
		jehoRetezec[i] = '\0';
	jehoDelka=len;
}

// Pevd znakov pole na Retezec
Retezec::Retezec(const char * const cRetezec)
{
	jehoDelka = strlen(cRetezec);
	jehoRetezec = new char[jehoDelka+1];
	for (unsigned short i = 0; i<jehoDelka; i++)
		jehoRetezec[i] = cRetezec[i];
	jehoRetezec[jehoDelka]='\0';
}

// Koprovac konstruktor
Retezec::Retezec (const Retezec & rhs)
{
	jehoDelka=rhs.PrevzitDelku();
	jehoRetezec = new char[jehoDelka+1];
	for (unsigned short i = 0; i<jehoDelka;i++)
		jehoRetezec[i] = rhs[i];
	jehoRetezec[jehoDelka] = '\0';
}

// Destruktor, uvoluje piazenou pam
Retezec::~Retezec ()
{
	delete [] jehoRetezec;
	jehoDelka = 0;
}

// Opertor rovno, uvoluje existujc pam
// a pak kopruje etzec a dlku
Retezec& Retezec::operator=(const Retezec & rhs)
{
	if (this == &rhs)
		return *this;
	delete [] jehoRetezec;
	jehoDelka=rhs.PrevzitDelku();
	jehoRetezec = new char[jehoDelka+1];
	for (unsigned short i = 0; i<jehoDelka;i++)
		jehoRetezec[i] = rhs[i];
	jehoRetezec[jehoDelka] = '\0';
	return *this;
}

// Nekonstantn opertor odsazen, vrac 
// odkaz na znak, aby jej bylo mon
// zmnit!
char & Retezec::operator[](unsigned short odsazeni)
{
	if (odsazeni > jehoDelka)
		return jehoRetezec[jehoDelka-1];
	else
		return jehoRetezec[odsazeni];
}

// Konstantn opertor odsazen pro pouit
// s konstantnmi objekty (viz koprovac konstruktor!)
char Retezec::operator[](unsigned short odsazeni) const
{
	if (odsazeni > jehoDelka)
		return jehoRetezec[jehoDelka-1];
	else
		return jehoRetezec[odsazeni];
}

// Vytv nov etzec pidnm aktulnho 
// etzce k rhs
Retezec Retezec::operator+(const Retezec& rhs)
{
	unsigned short celkovaDelka = jehoDelka + rhs.PrevzitDelku();
	Retezec docasny(celkovaDelka);
	unsigned short i;
	for ( i= 0; i<jehoDelka; i++)
		docasny[i] = jehoRetezec[i];
	for (unsigned short j = 0; j<rhs.PrevzitDelku(); j++, i++)
		docasny[i] = rhs[j];
	docasny[celkovaDelka]='\0';
	return docasny;
}

// Mn aktuln etzec, nevrac nic
void Retezec::operator+=(const Retezec& rhs)
{
	unsigned short rhsDelka = rhs.PrevzitDelku();
	unsigned short celkovaDelka = jehoDelka + rhsDelka;
	Retezec  docasny(celkovaDelka);
	unsigned short i;
	for (i = 0; i<jehoDelka; i++)
		docasny[i] = jehoRetezec[i];
	for (unsigned short j = 0; j<rhs.PrevzitDelku(); j++, i++)
		docasny[i] = rhs[i-jehoDelka];
	docasny[celkovaDelka]='\0';
	*this = docasny;
}

int main()
{
	Retezec s1("pocatecni test");
	cout << "S1:\t" << s1.PrevzitRetezec() << endl;

	char * docasny = "Ahoj, svete";
	s1 = docasny;
	cout << "S1:\t" << s1.PrevzitRetezec() << endl;

	char docasnyDve[20];
	strcpy(docasnyDve,"; jsem tu rad!");
	s1 += docasnyDve;
	cout << "docasnyDve:\t" << docasnyDve << endl;
	cout << "S1:\t" << s1.PrevzitRetezec() << endl;

	cout << "S1[4]:\t" << s1[4] << endl;
	s1[4]='x';
	cout << "S1:\t" << s1.PrevzitRetezec() << endl;

	cout << "S1[999]:\t" << s1[999] << endl;

	Retezec s2(" Jiny retezec");
	Retezec s3;
	s3 = s1+s2;
	cout << "S3:\t" << s3.PrevzitRetezec() << endl;

	Retezec s4;
	s4 = "Proc tohle funguje?";
	cout << "S4:\t" << s4.PrevzitRetezec() << endl;
	return 0;
}
