// Vpis 14.10
// Odvozen typ ADT z jinch typ ADT
#include <iostream>
using namespace std;

enum BARVA { Cervena, Zelena, Modra, Zluta, Bila, Cerna, Hneda } ;

class Zvire        // spolen tda pro Savec and Ryba
{
public:
    Zvire(int);
    virtual ~Zvire() { cout << "Destruktor Zvire...\n"; }
    virtual int ZjistitVek() const { return jehoVek; }
    virtual void ZadatVek(int vek) { jehoVek = vek; }
    virtual void Spat() const = 0;
    virtual void Jist() const = 0;
    virtual void Reprodukovat() const = 0;
    virtual void Pohybovat() const = 0;
    virtual void Mluvit() const = 0;
private:
    int jehoVek;
};

Zvire::Zvire(int vek):
jehoVek(vek)
{
    cout << "Konstruktor Zvire...\n";
}

class Savec : public Zvire
{
public:
    Savec(int vek):Zvire(vek)
        { cout << "Konstruktor Savec...\n";}
    virtual ~Savec() { cout << "Destruktor Savec...\n";}
    virtual void Reprodukovat() const
        { cout << "Znazorneni reprodukce savce...\n"; }
};

class Ryba : public Zvire
{
public:
    Ryba(int vek):Zvire(vek)
        { cout << "Konstruktor Ryba...\n";}
    virtual ~Ryba() {cout << "Destruktor Ryba...\n";  }
    virtual void Spat() const { cout << "ryba spi...\n"; }
    virtual void Jist() const { cout << "ryba se krmi...\n"; }
    virtual void Reprodukovat() const
        { cout << "ryba klade jikry...\n"; }
    virtual void Pohybovat() const
        { cout << "ryba plave...\n";   }
    virtual void Mluvit() const { }
};

class Kun : public Savec
{
public:
    Kun(int vek, BARVA barva ):
    Savec(vek), jehoBarva(barva)
        { cout << "Konstruktor Kun...\n"; }
    virtual ~Kun() { cout << "Destruktor Kun...\n"; }
    virtual void Mluvit()const { cout << "Iihaha!... \n"; }
    virtual BARVA GetItsColor() const { return jehoBarva; }
    virtual void Spat() const
        { cout << "kun spi...\n"; }
    virtual void Jist() const { cout << "kun se krmi...\n"; }
    virtual void Pohybovat() const { cout << "kun bezi...\n";}

protected:
    BARVA jehoBarva;
};

class Pes : public Savec
{
public:
    Pes(int vek, BARVA barva ):
    Savec(vek), jehoBarva(barva)
        { cout << "Konstruktor Pes...\n"; }
    virtual ~Pes() { cout << "Destruktor Pes...\n"; }
    virtual void Mluvit()const { cout << "Haf!... \n"; }
    virtual void Spat() const { cout << "pes spi...\n"; }
    virtual void Jist() const { cout << "pes se krmi...\n"; }
    virtual void Pohybovat() const  { cout << "pes bezi...\n"; }
    virtual void Reprodukovat() const
        { cout << "psi se reprodukuji...\n"; }

protected:
    BARVA jehoBarva;
};

int main()
{
    Zvire *pZvire=0;
    int volba;
    bool fKonec = false;

    while (1)
    {
        cout << "(1)Pes (2)Kun (3)Ryba (0)Konec: ";
        cin >> volba;

        switch (volba)
        {
        case 1: pZvire = new Pes(5,Hneda);
                break;
        case 2: pZvire = new Kun(4,Cerna);
                break;
        case 3: pZvire = new Ryba (5);
                break;
        default: fKonec = true;
                break;
        }
        if (fKonec)
            break;

        pZvire->Mluvit();
        pZvire->Jist();
        pZvire->Reprodukovat();
        pZvire->Pohybovat();
        pZvire->Spat();
        delete pZvire;
        cout << "\n";
    }
    return 0;
}
