// Vpis 16.4 Pedvn hodnotou
#include "Retezec.hpp"

class Zamestnanec
{
public:
    Zamestnanec();
    Zamestnanec(char *, char *, char *, long);
    ~Zamestnanec();
    Zamestnanec(const Zamestnanec&);
    Zamestnanec & operator= (const Zamestnanec &);

    const Retezec & ZjistitJmeno() const
        { return jehoJmeno; }
    const Retezec & ZjistitPrijmeni() const { return jehoPrijmeni; }
    const Retezec & ZjistitAdresu() const { return jehoAdresa; }
    long ZjistitPlat() const { return jehoPlat; }

    void ZadatJmeno(const Retezec & jmeno)
        { jehoJmeno = jmeno; }
    void ZadatPrijmeni(const Retezec & prijmeni)
        { jehoPrijmeni = prijmeni; }
    void ZadatAdresu(const Retezec & adresa)
        { jehoAdresa = adresa; }
    void ZadatPlat(long plat) { jehoPlat = plat; }
private:
    Retezec    jehoJmeno;
    Retezec    jehoPrijmeni;
    Retezec    jehoAdresa;
    long       jehoPlat;
};

Zamestnanec::Zamestnanec():
    jehoJmeno(""),
    jehoPrijmeni(""),
    jehoAdresa(""),
    jehoPlat(0)
{}

Zamestnanec::Zamestnanec(char * jmeno, char * prijmeni,
    char * adresa, long plat):
    jehoJmeno(jmeno),
    jehoPrijmeni(prijmeni),
    jehoAdresa(adresa),
    jehoPlat(plat)
{}

Zamestnanec::Zamestnanec(const Zamestnanec & pravaStrana):
    jehoJmeno(pravaStrana.ZjistitJmeno()),
    jehoPrijmeni(pravaStrana.ZjistitPrijmeni()),
    jehoAdresa(pravaStrana.ZjistitAdresu()),
    jehoPlat(pravaStrana.ZjistitPlat())
{}

Zamestnanec::~Zamestnanec() {}

Zamestnanec & Zamestnanec::operator= (const Zamestnanec & pravaStrana)
{
    if (this == &pravaStrana)
        return *this;

    jehoJmeno = pravaStrana.ZjistitJmeno();
    jehoPrijmeni = pravaStrana.ZjistitPrijmeni();
    jehoAdresa = pravaStrana.ZjistitAdresu();
    jehoPlat = pravaStrana.ZjistitPlat();

    return *this;
}

void TiskovaFunkce(Zamestnanec);
void oTiskovaFunkce(const Zamestnanec&);

int main()
{
    Zamestnanec Edie("Jane","Doe","U parku 12", 20000);
    Edie.ZadatPlat(20000);
    Edie.ZadatJmeno("Edythe");
    Retezec Prijmeni("Levine");
    Edie.ZadatPrijmeni(Prijmeni);

    cout << "Pocet konstruktoru: " ;
    cout << Retezec::PocetKonstruktoru << endl;
    oTiskovaFunkce(Edie);
    cout << "Pocet konstruktoru: ";
    cout << Retezec::PocetKonstruktoru << endl;
    TiskovaFunkce(Edie);
    cout << "Pocet konstruktoru: ";
    cout << Retezec::PocetKonstruktoru << endl;
    return 0;
}
void TiskovaFunkce (Zamestnanec Edie)
{
    cout << "Jmeno: ";
    cout << Edie.ZjistitJmeno().PrevzitRetezec();
    cout << " " << Edie.ZjistitPrijmeni().PrevzitRetezec();
    cout << ".\nAdresa: ";
    cout << Edie.ZjistitAdresu().PrevzitRetezec();
    cout << ".\nPlat: " ;
    cout << Edie.ZjistitPlat();
    cout << endl;
}

void oTiskovaFunkce (const Zamestnanec& Edie)
{
    cout << "Jmeno: ";
    cout << Edie.ZjistitJmeno().PrevzitRetezec();
    cout << " " << Edie.ZjistitPrijmeni().PrevzitRetezec();
    cout << "\nAdresa: ";
    cout << Edie.ZjistitAdresu().PrevzitRetezec();
    cout << "\nPlat: " ;
    cout << Edie.ZjistitPlat();
    cout << endl;
}
