// Vpis 16.5 Delegovn obsaen td SeznamCasti

#include <iostream>
using namespace std;

// **************** Soust ************

// Abstraktn bzov tda soust
class Cast
{
public:
    Cast():jejiCisloCasti(1) {}
    Cast(int CisloCasti):
    jejiCisloCasti(CisloCasti){}
    virtual ~Cast(){}
    int ZjistitCisloCasti() const
        { return jejiCisloCasti; }
    virtual void Zobrazit() const =0;
private:
    int jejiCisloCasti;
};

// implementace ist virtuln funkce, aby mohlo 
// dochzet k zetzen v odvozench tdch
void Cast::Zobrazit() const
{
    cout << "\nCislo soucasti: " << jejiCisloCasti << endl;
}

// **************** Soust auta ************

class CastAuta : public Cast
{
public:
    CastAuta():jehoRokModelu(94){}
    CastAuta(int rok, int cisloCasti);
    virtual void Zobrazit() const
    {
    Cast::Zobrazit();
    cout << "Rok modelu: ";
    cout << jehoRokModelu << endl;
    }
private:
    int jehoRokModelu;
};

CastAuta::CastAuta(int rok, int cisloCasti):
    jehoRokModelu(rok),
    Cast(cisloCasti)
{}


// **************** Soust letadla ************

class CastLetadla : public Cast
{
public:
    CastLetadla():jehoCisloMotoru(1){};
    CastLetadla
    (int CisloMotoru, int CisloCasti);
    virtual void Zobrazit() const
    {
    Cast::Zobrazit();
    cout << "Cislo motoru: ";
    cout << jehoCisloMotoru << endl;
    }
private:
    int jehoCisloMotoru;
};

CastLetadla::CastLetadla
(int CisloMotoru, int CisloCasti):
    jehoCisloMotoru(CisloMotoru),
    Cast(CisloCasti)
{}

// **************** Uzel sousti ************
class UzelCasti
{
public:
    UzelCasti (Cast*);
    ~UzelCasti();
    void ZadatDalsi(UzelCasti * uzel)
        { jehoDalsi = uzel; }
    UzelCasti * ZjistitDalsi() const;
    Cast * ZjistitCast() const;
private:
    Cast *jehoCast;
    UzelCasti * jehoDalsi;
};
// Implementace UzelCasti...

UzelCasti::UzelCasti(Cast* pCast):
    jehoCast(pCast),
    jehoDalsi(0)
{}

UzelCasti::~UzelCasti()
{
    delete jehoCast;
    jehoCast = 0;
    delete jehoDalsi;
    jehoDalsi = 0;
}

// Vrac NULL, neexistuje li dal UzelCasti
UzelCasti * UzelCasti::ZjistitDalsi() const
{
    return jehoDalsi;
}

Cast * UzelCasti::ZjistitCast() const
{
    if (jehoCast)
        return jehoCast;
    else
        return NULL; //chyba
}



// **************** Seznam soust ************
class SeznamCasti
{
public:
    SeznamCasti();
    ~SeznamCasti();
    // Potebuje koprovac konstruktor a opertor rovnosti!
    void     Iterovat(void (Cast::*f)()const) const;
    Cast*    Najit(int & pozice, int CisloCasti)  const;
    Cast*    ZjistitPrvni() const;
    void     Vlozit(Cast *);
    Cast*    operator[](int) const;
    int      ZjistitPocet() const { return jejichPocet; }
    static   SeznamCasti& PrevzitGlobalniSeznamCasti()
    {
    return  GlobalniSeznamCasti;
    }
private:
    UzelCasti * pHlava;
    int jejichPocet;
    static SeznamCasti GlobalniSeznamCasti;
};

SeznamCasti SeznamCasti::GlobalniSeznamCasti;


SeznamCasti::SeznamCasti():
    pHlava(0),
    jejichPocet(0)
{}

SeznamCasti::~SeznamCasti()
{
    delete pHlava;
}

Cast*   SeznamCasti::ZjistitPrvni() const
{
    if (pHlava)
        return pHlava->ZjistitCast();
    else
        return NULL;  // zachycen chyby
}

Cast *  SeznamCasti::operator[](int odsazeni) const
{
    UzelCasti* pUzel = pHlava;

    if (!pHlava)
        return NULL; // zachycen chyby

    if (odsazeni > jejichPocet)
        return NULL; // chyba

    for (int i=0;i<odsazeni; i++)
        pUzel = pUzel->ZjistitDalsi();

    return   pUzel->ZjistitCast();
}

Cast*   SeznamCasti::Najit(
    int & pozice,
    int CisloCasti)  const
{
    UzelCasti * pUzel = 0;
    for (pUzel = pHlava, pozice = 0;
            pUzel!=NULL;
            pUzel = pUzel->ZjistitDalsi(), pozice++)
    {
        if (pUzel->ZjistitCast()->ZjistitCisloCasti() == CisloCasti)
            break;
    }
    if (pUzel == NULL)
        return NULL;
    else
        return pUzel->ZjistitCast();
}

void SeznamCasti::Iterovat(void (Cast::*funkce)()const) const
{
    if (!pHlava)
        return;
    UzelCasti* pUzel = pHlava;
    do
        (pUzel->ZjistitCast()->*funkce)();
    while (pUzel = pUzel->ZjistitDalsi());
}

void SeznamCasti::Vlozit(Cast* pCast)
{
    UzelCasti * pUzel = new UzelCasti(pCast);
    UzelCasti * pAktualni = pHlava;
    UzelCasti * pDalsi = 0;

    int Nova =  pCast->ZjistitCisloCasti();
    int Next = 0;
    jejichPocet++;

    if (!pHlava)
    {
        pHlava = pUzel;
        return;
    }

    // Je li tahle men ne hlava, pak
    // se stane novou hlavou
    if (pHlava->ZjistitCast()->ZjistitCisloCasti() > Nova)
    {
        pUzel->ZadatDalsi(pHlava);
        pHlava = pUzel;
        return;
    }

    for (;;)
    {
        // Nen li dn dal, pidat tuto novou
        if (!pAktualni->ZjistitDalsi())
        {
            pAktualni->ZadatDalsi(pUzel);
            return;
        }

        // Pokud pat za tuto, ale ped dal, pak ji
        // vloit sem, jinak pejt na dal
        pDalsi = pAktualni->ZjistitDalsi();
        Next = pDalsi->ZjistitCast()->ZjistitCisloCasti();
        if (Next > Nova)
        {
            pAktualni->ZadatDalsi(pUzel);
            pUzel->ZadatDalsi(pDalsi);
            return;
        }
        pAktualni = pDalsi;
    }
}



class KatalogCasti
{
public:
    void Vlozit(Cast *);
    int Existuje(int CisloCasti);
    Cast * Prevzit(int CisloCasti);
    operator+(const KatalogCasti &);
    void ZobrazitVse() { tenSeznamCasti.Iterovat(Cast::Zobrazit); }
private:
    SeznamCasti tenSeznamCasti;
};

void KatalogCasti::Vlozit(Cast * novaCast)
{
    int cisloCasti =  novaCast->ZjistitCisloCasti();
    int odsazeni;

    if (!tenSeznamCasti.Najit(odsazeni, cisloCasti))
        tenSeznamCasti.Vlozit(novaCast);
    else
    {
        cout << cisloCasti << " bylo ";
        switch (odsazeni)
        {
        case 0:  cout << "prvni "; break;
        case 1:  cout << "druhe "; break;
        case 2:  cout << "treti "; break;
        default: cout << odsazeni+1 << ". ";
        }
        cout << "zadani. Odmitnuto!\n";
    }
}

int KatalogCasti::Existuje(int CisloCasti)
{
    int odsazeni;
    tenSeznamCasti.Najit(odsazeni,CisloCasti);
    return odsazeni;
}

Cast * KatalogCasti::Prevzit(int CisloCasti)
{
    int odsazeni;
    Cast * taCast = tenSeznamCasti.Najit(odsazeni, CisloCasti);
    return taCast;
}


int main()
{
    KatalogCasti kc;
    Cast * pCast = 0;
    int CisloCasti;
    int hodnota;
    int volba;

    while (1)
    {
        cout << "(0)Konec (1)Auto (2)Letadlo: ";
        cin >> volba;

        if (!volba)
        break;

        cout << "Nove CisloCasti?: ";
        cin >>  CisloCasti;

        if (volba == 1)
        {
            cout << "Rok modelu?: ";
            cin >> hodnota;
            pCast = new CastAuta(hodnota,CisloCasti);
        }
        else
        {
            cout << "Cislo motoru?: ";
            cin >> hodnota;
            pCast = new CastLetadla(hodnota,CisloCasti);
        }
        kc.Vlozit(pCast);
    }
    kc.ZobrazitVse();
    return 0;
}
