//Vpis 19.2 Implementace ablony pole
#include <iostream>

const int VychoziVelikost = 10;

// Deklarujeme jednoduchou tdu Zvire, abychom mohli
// vytvoit pole zvat

class Zvire
{
public:
    Zvire(int);
    Zvire();
    ~Zvire() {}
    int ZjistitVahu() const { return jehoVaha; }
    void Zobrazit() const { std::cout << jehoVaha; }
private:
    int jehoVaha;
};

Zvire::Zvire(int vaha):
    jehoVaha(vaha)
{}

Zvire::Zvire():
    jehoVaha(0)
{}


template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{
public:
    // Konstruktory
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp; }

    // Opertory
    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
        { return pTyp[odsazeni]; }

    // Pstupov metody
    int ZjistitVelikost() const { return jehoVelikost; }

private:
    T *pTyp;
    int  jehoVelikost;
};

// Nsleduj implementace...

// Implementace konstruktoru
template <class T>
Pole<T>::Pole(int velikost):
jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = 0;
}

// Koprovac konstruktor
template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

// Opertor =
template <class T>
Pole<T>& Pole<T>::operator=(const Pole &pravaStrana)
{
    if (this == &pravaStrana)
        return *this;
    delete [] pTyp;
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
    return *this;
}

// Ovldac program
int main()
{
    Pole<int> toPole;      // pole celch sel
    Pole<Zvire> toZoo;     // pole zvat
    Zvire *pZvire;

    // Naplnn pol
    for (int i = 0; i < toPole.ZjistitVelikost(); i++)
    {
        toPole[i] = i*2;
        pZvire = new Zvire(i*3);
        toZoo[i] = *pZvire;
        delete pZvire;
    }

    // Vytitn obsahu pol
    for (int j = 0; j < toPole.ZjistitVelikost(); j++)
    {
        std::cout << "toPole[" << j << "]:\t";
        std::cout << toPole[j] << "\t\t";
        std::cout << "toZoo[" << j << "]:\t";
        toZoo[j].Zobrazit();
        std::cout << std::endl;
    }

    return 0;
}
