// Vpis 19.3 - Ptelsk funkce mimo ablonu

#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

// Deklarujeme jednoduchou tdu Zvire, abychom mohli
// vytvoit pole zvat

class Zvire
{
public:
    Zvire(int);
    Zvire();
    ~Zvire() {}
    int ZjistitVahu() const { return jehoVaha; }
    void Zobrazit() const { cout << jehoVaha; }
private:
    int jehoVaha;
};

Zvire::Zvire(int vaha):
    jehoVaha(vaha)
{}

Zvire::Zvire():
    jehoVaha(0)
{}

template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{
public:
    // Konstruktory
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp; }

    // Opertory
    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
    { return pTyp[odsazeni]; }

    // Pstupov metody
    int ZjistitVelikost() const { return jehoVelikost; }

    // Ptelsk funkce
    friend void Vtrhnout(Pole<int>);

private:
    T *pTyp;
    int  jehoVelikost;
};

// Ptelsk funkce. Nejedn se o ablonu, lze pouvat
// pouze s poli int! Zkoum soukrom data.
void Vtrhnout(Pole<int> toPole)
{
    cout << "\n*** Vtrhnout ***\n";
    for (int i = 0; i < toPole.jehoVelikost; i++)
        cout << "i: " <<    toPole.pTyp[i] << endl;
    cout << "\n";
}

// Nsleduj implementace...

// Implementace konstruktoru
template <class T>
Pole<T>::Pole(int velikost):
    jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = 0;
}

// Koprovac konstruktor
template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

// Opertor =
template <class T>
Pole<T>& Pole<T>::operator=(const Pole &pravaStrana)
{
    if (this == &pravaStrana)
        return *this;
    delete [] pTyp;
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
    return *this;
}

// Ovldac program
int main()
{
    Pole<int> toPole;      // pole celch sel
    Pole<Zvire> toZoo;     // pole zvat
    Zvire *pZvire;

    // Naplnn pol
    for (int i = 0; i < toPole.ZjistitVelikost(); i++)
    {
        toPole[i] = i*2;
        pZvire = new Zvire(i*3);
        toZoo[i] = *pZvire;
    }

    int j;
    for (j = 0; j < toPole.ZjistitVelikost(); j++)
    {
        cout << "toZoo[" << j << "]:\t";
        toZoo[j].Zobrazit();
        cout << endl;
    }
    cout << "Nyni pouzivame pratelskou funkci ";
    cout << "k vyhledani clenu Pole<int>";
    Vtrhnout(toPole);

    cout << "\n\nHotovo.\n";
    return 0;
}
