//Vpis 19.4 Pouit opertoru ostream
#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

class Zvire
{
public:
    Zvire(int);
    Zvire();
    ~Zvire() {}
    int ZjistitVahu() const { return jehoVaha; }
    void Zobrazit() const { cout << jehoVaha; }
private:
    int jehoVaha;
};

Zvire::Zvire(int vaha):
    jehoVaha(vaha)
{}

Zvire::Zvire():
    jehoVaha(0)
{}

template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{
public:
    // Konstruktory
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp; }

    // Opertory
    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
        { return pTyp[odsazeni]; }

    // Pstupov metody
    int ZjistitVelikost() const { return jehoVelikost; }

    friend ostream& operator<< (ostream&, Pole<T>&);

private:
    T *pTyp;
    int  jehoVelikost;
};

template <class T>
ostream& operator<< (ostream& vystup, Pole<T>& toPole)
{
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
        vystup << "[" << i << "] " << toPole[i] << endl;
    return vystup;
}

// Nsleduj implementace...

// Implementace konstruktoru
template <class T>
Pole<T>::Pole(int velikost):
    jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = 0;
}

// Koprovac konstruktor
template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

// Opertor =
template <class T>
Pole<T>& Pole<T>::operator=(const Pole &pravaStrana)
{
    if (this == &pravaStrana)
        return *this;
    delete [] pTyp;
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
    return *this;
}

int main()
{
    bool Zastavit = false;       // pznak smyky
    int odsazeni, hodnota;
    Pole<int> toPole;

    while (!Zastavit)
    {
        cout << "Zadejte odsazeni (0-9) ";
        cout << "a hodnotu. (-1 pro zastaveni): " ;
        cin >> odsazeni >> hodnota;

        if (odsazeni < 0)
            break;

        if (odsazeni > 9)
        {
            cout << "***Prosim pouzivejte hodnoty mezi 0 a 9.***\n";
            continue;
        }

        toPole[odsazeni] = hodnota;
    }

    cout << "\nZde mame cele pole:\n";
    cout << toPole << endl;
    return 0;
}
