//Vpis 19.5 Pedvn objekt ablon funkcm a z funkc
#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

// Prost tda pro pidn do pol
class Zvire
{
public:
    // Konstruktory
    Zvire(int);
    Zvire();
    ~Zvire();

    // Pstupov metody
    int ZjistitVahu() const { return jehoVaha; }
    void ZadatVahu(int taVaha) { jehoVaha = taVaha; }

    // Ptelsk opertory
    friend ostream& operator<< (ostream&, const Zvire&);

private:
    int jehoVaha;
};

// Opertor vyjmut pro tisk zvat
ostream& operator<<
(ostream& tenProud, const Zvire& toZvire)
{
    tenProud << toZvire.ZjistitVahu();
    return tenProud;
}

Zvire::Zvire(int vaha):
jehoVaha(vaha)
{
    // cout << "Zvire(int)\n";
}

Zvire::Zvire():
jehoVaha(0)
{
    // cout << "Zvire()\n";
}

Zvire::~Zvire()
{
    // cout << "Zniceni zvirete...\n";
}

template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{ 
public:
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp; }

    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
        { return pTyp[odsazeni]; }
    int ZjistitVelikost() const { return jehoVelikost; }

    // Ptelsk funkce 
    friend ostream& operator<< (ostream&, const Pole<T>&);

private:
    T *pTyp;
    int  jehoVelikost;
};

template <class T>
ostream& operator<< (ostream& vystup, const Pole<T>& toPole)
{
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
        vystup << "[" << i << "] " << toPole[i] << endl;
    return vystup;
}

// Nsleduj implementace...

// Implementace konstruktoru
template <class T>
Pole<T>::Pole(int velikost):
jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = 0;
}

// Koprova konstruktor
template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

void FunkcePlneniCisly(Pole<int>& toPole);
void FunkcePlneniZviraty(Pole<Zvire>& toPole);

int main()
{
    Pole<int> poleCisel;
    Pole<Zvire> poleZvirat;
    FunkcePlneniCisly(poleCisel);
    FunkcePlneniZviraty(poleZvirat);
    cout << "poleCisel...\n" << poleCisel;
    cout << "\npoleZvirat...\n" << poleZvirat << endl;
    return 0;
}

void FunkcePlneniCisly(Pole<int>& toPole)
{
    bool Zastavit = false;
    int odsazeni, hodnota;
    while (!Zastavit)
    {
        cout << "Zadejte odsazeni (0-9) ";
        cout << "a hodnotu. (-1 pro zastaveni): " ;
        cin >> odsazeni >> hodnota;
        if (odsazeni < 0)
            break;
        if (odsazeni > 9)
        {
            cout << "***Prosim pouzivejte hodnoty mezi 0 a 9.***\n";
            continue;
        }
        toPole[odsazeni] = hodnota;
    }
}

void FunkcePlneniZviraty(Pole<Zvire>& toPole)
{
    Zvire * pZvire;
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
    {
        pZvire = new Zvire;
        pZvire->ZadatVahu(i*100);
        toPole[i] = *pZvire;
        delete pZvire;  // do pole byla vloena kopie
    }
}
