#include <iostream>
using namespace std;

const int VychoziVelikost = 3;

// Jednoduch tda pro pidvn do pol
class Zvire
{
public:
    // Konstruktory
    Zvire(int);
    Zvire();
    ~Zvire();

    // Pstupov metody
    int ZjistitVahu() const { return jehoVaha; }
    void ZadatVahu(int taVaha) { jehoVaha = taVaha; }

    // Ptelsk opertory
    friend ostream& operator<< (ostream&, const Zvire&);

private:
    int jehoVaha;
};

// Opertor vyjmut pro tisk zvat
ostream& operator<<
(ostream& tenProud, const Zvire& toZvire)
{
    tenProud << toZvire.ZjistitVahu();
    return tenProud;
}

Zvire::Zvire(int vaha):
jehoVaha(vaha)
{
    cout << "zvire(int) ";
}

Zvire::Zvire():
jehoVaha(0)
{
    cout << "zvire() ";
}

Zvire::~Zvire()
{
    cout << "Zniceni zvirete...\n";
}

template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{
public:
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp; }

    // Opertory
    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
    { return pTyp[odsazeni]; }

    // Pstupov metody
    int ZjistitVelikost() const { return jehoVelikost; }

    // Ptelsk funkce
    // friend ostream& operator<< (ostream&, const Pole<T>&);

private:
    T *pTyp;
    int  jehoVelikost;
};

template <class T>
Pole<T>::Pole(int velikost = VychoziVelikost):
jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = (T)0;
}

template <class T>
Pole<T>& Pole<T>::operator=(const Pole &pravaStrana)
{
    if (this == &pravaStrana)
        return *this;
    delete [] pTyp;
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
    return *this;
}

template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

template <class T>
ostream& operator<< (ostream& vystup, const Pole<T>& toPole)
{
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
        vystup << "[" << i << "] " << toPole[i] << endl;
    return vystup;
}

Pole<Zvire>::Pole(int VelikostPoleZvirat):
jehoVelikost(VelikostPoleZvirat)
{
    pTyp = new Zvire[VelikostPoleZvirat];
}

void FunkcePlneniCisly(Pole<int>& toPole);
void FunkcePlneniZviraty(Pole<Zvire>& toPole);

int main()
{
    Pole<int> poleCisel;
    Pole<Zvire> poleZvirat;
    FunkcePlneniCisly(poleCisel);
    FunkcePlneniZviraty(poleZvirat); 
    cout << "\npoleCisel...\n" << poleCisel;
    cout << "\npoleZvirat...\n" << poleZvirat << endl;
    return 0;
}

void FunkcePlneniCisly(Pole<int>& toPole)
{
    bool Zastavit = false;
    int odsazeni, hodnota;
    while (!Zastavit)
    {
        cout << "Zadejte odsazeni (0-2) a hodnotu. ";
        cout << "(-1 pro zastaveni): " ;
        cin >> odsazeni >> hodnota;
        if (odsazeni < 0)
            break;
        if (odsazeni > 2)
        {
            cout << "***Prosim pouzivejte hodnoty mezi 0 a 2.***\n";
            continue;
        }
        toPole[odsazeni] = hodnota;
    }
}

void FunkcePlneniZviraty(Pole<Zvire>& toPole)
{
    Zvire * pZvire;
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
    {
        pZvire = new Zvire(i*10);
        toPole[i] = *pZvire;
        delete pZvire;
    }
}
