#include <iostream>
using namespace std;

const int VychoziVelikost = 3;

// Jednoduch tda pro pidvn do pol
class Zvire
{
public:
    // Konstruktory
    Zvire(int);
    Zvire();
    ~Zvire();

    // Pstupov metody
    int ZjistitVahu() const { return jehoVaha; }
    void ZadatVahu(int taVaha) { jehoVaha = taVaha; }

    // Ptelsk opertory
    friend ostream& operator<< (ostream&, const Zvire&);

private:
    int jehoVaha;
};

// Opertor vyjmut pro tisk zvat
ostream& operator<<
    (ostream& tenProud, const Zvire& toZvire)
{
    tenProud << toZvire.ZjistitVahu();
    return tenProud;
}

Zvire::Zvire(int vaha):
    jehoVaha(vaha)
{
    //cout << "zvire(int) ";
}

Zvire::Zvire():
    jehoVaha(0)
{
    //cout << "zvire() ";
}
 
Zvire::~Zvire()
{
    //cout << "Zniceni zvirete...";
}

template <class T>    // deklarace ablony a parametru
class Pole            // parametrizovan tda
{
public:
    // Konstruktory
    Pole(int jehoVelikost = VychoziVelikost);
    Pole(const Pole &pravaStrana);
    ~Pole() { delete [] pTyp;   jehoPocetPoli--; }

    // Opertory
    Pole& operator=(const Pole&);
    T& operator[](int odsazeni) { return pTyp[odsazeni]; }
    const T& operator[](int odsazeni) const
    { return pTyp[odsazeni]; }

    // Pstupov metody
    int ZjistitVelikost() const { return jehoVelikost; }
    static int ZjistitPocetPoli() { return jehoPocetPoli; }

    // Ptelsk funkce
    friend ostream& operator<< (ostream&, const Pole<T>&);

private:
    T *pTyp;
    int  jehoVelikost;
    static int jehoPocetPoli;
};

template <class T>
int Pole<T>::jehoPocetPoli = 0;

template <class T>
Pole<T>::Pole(int velikost = VychoziVelikost):
    jehoVelikost(velikost)
{
    pTyp = new T[velikost];
    for (int i = 0; i<velikost; i++)
        pTyp[i] = (T)0;
    jehoPocetPoli++;
}

template <class T>
Pole<T>& Pole<T>::operator=(const Pole &pravaStrana)
{
    if (this == &pravaStrana)
        return *this;
    delete [] pTyp;
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
}

template <class T>
Pole<T>::Pole(const Pole &pravaStrana)
{
    jehoVelikost = pravaStrana.ZjistitVelikost();
    pTyp = new T[jehoVelikost];
    for (int i = 0; i<jehoVelikost; i++)
        pTyp[i] = pravaStrana[i];
    jehoPocetPoli++;
}

template <class T>
ostream& operator<< (ostream& vystup, const Pole<T>& toPole) {
    for (int i = 0; i<toPole.ZjistitVelikost(); i++)
        vystup << "[" << i << "] " << toPole[i] << endl;
    return vystup;
}

int main()
{
    cout << Pole<int>::ZjistitPocetPoli() << " poli celych cisel\n";
    cout << Pole<Zvire>::ZjistitPocetPoli();
    cout << " poli zvirat\n\n";
    Pole<int> poleCisel;
    Pole<Zvire> poleZvirat;

    cout << poleCisel.ZjistitPocetPoli() << " poli celych cisel\n";
    cout << poleZvirat.ZjistitPocetPoli();
    cout << " poli zvirat\n\n";

    Pole<int> *pIntArray = new Pole<int>;

    cout << Pole<int>::ZjistitPocetPoli() << " poli celych cisel\n";
    cout << Pole<Zvire>::ZjistitPocetPoli();
    cout << " poli zvirat\n\n";

    delete pIntArray;

    cout << Pole<int>::ZjistitPocetPoli() << " poli celych cisel\n";
    cout << Pole<Zvire>::ZjistitPocetPoli();
    cout << " poli zvirat\n\n";
    return 0;
}
