#include <iostream>
#include <string>
#include <vector>
using namespace std;

class Student
{
public:
    Student();
    Student(const string& jmeno, const int vek);
    Student(const Student& pravaStrana);
    ~Student();

    void    ZadatJmeno(const string& jmeno);
    string    ZjistitJmeno()    const;
    void    ZadatVek(const int vek);
    int        ZjistitVek()    const;

    Student& operator=(const Student& pravaStrana);

private:
    string jehoJmeno;
int jehoVek;
};

Student::Student()
: jehoJmeno("Novy student"), jehoVek(16)
{}

Student::Student(const string& jmeno, const int vek)
: jehoJmeno(jmeno), jehoVek(vek)
{}

Student::Student(const Student& pravaStrana)
: jehoJmeno(pravaStrana.ZjistitJmeno()), jehoVek(pravaStrana.ZjistitVek())
{}

Student::~Student()
{}

void Student::ZadatJmeno(const string& jmeno)
{
    jehoJmeno = jmeno;
}

string Student::ZjistitJmeno() const
{
    return jehoJmeno;
}

void Student::ZadatVek(const int vek)
{
    jehoVek = vek;
}

int Student::ZjistitVek() const
{
    return jehoVek;
}

Student& Student::operator=(const Student& pravaStrana)
{
    jehoJmeno = pravaStrana.ZjistitJmeno();
    jehoVek = pravaStrana.ZjistitVek();
    return *this;
}

ostream& operator<<(ostream& os, const Student& pravaStrana)
{
    os << pravaStrana.ZjistitJmeno() << " ma " << pravaStrana.ZjistitVek();
    os << " let";
    return os;
}

template<class T>
// Zobrazen vlastnost vektoru
void ZobrazitVektor(const vector<T>& v);    

typedef vector<Student>    Prednaska;

int main()
{
    Student Harry;
    Student Sally("Sally", 15);
    Student Bill("Bill", 17);
    Student Peter("Peter", 16);

    Prednaska    PrazdnaPrednaska;
    cout << "PrazdnaPrednaska:\n";
    ZobrazitVektor(PrazdnaPrednaska);

    Prednaska RozsirovanaPrednaska(3);
    cout << "RozsirovanaPrednaska(3):\n";
    ZobrazitVektor(RozsirovanaPrednaska);

    RozsirovanaPrednaska[0] = Harry;
    RozsirovanaPrednaska[1] = Sally;
    RozsirovanaPrednaska[2] = Bill;
    cout << "RozsirovanaPrednaska(3) po prirazeni studentu:\n";
    ZobrazitVektor(RozsirovanaPrednaska);

    RozsirovanaPrednaska.push_back(Peter);
    cout << "RozsirovanaPrednaska() po pridani 4. studenta:\n";
    ZobrazitVektor(RozsirovanaPrednaska);

    RozsirovanaPrednaska[0].ZadatJmeno("Harry");
    RozsirovanaPrednaska[0].ZadatVek(18);
    cout << "RozsirovanaPrednaska() po zadani:\n";
    ZobrazitVektor(RozsirovanaPrednaska);

    return 0;
}

//
// Zobrazen vlastnost vektoru
//
template<class T>
void ZobrazitVektor(const vector<T>& v)
{
    cout << "max_size() = " << v.max_size();
    cout << "\tsize() = " << v.size();
    cout << "\tcapacity() = " << v.capacity();
    cout << "\t" << (v.empty()? "prazdna": "neprazdna");
    cout << "\n";

    for (int i = 0; i < v.size(); ++i)
        cout << v[i] << "\n";

    cout << endl;
}
