#include <iostream>
#include <string>
#include <map>
using namespace std;

class Student
{
public:
    Student();
    Student(const string& jmeno, const int vek);
    Student(const Student& pravaStrana);
    ~Student();

    void    ZadatJmeno(const string& jmeno);
    string    ZjistitJmeno()    const;
    void    ZadatVek(const int vek);
    int        ZjistitVek()    const;

    Student& operator=(const Student& pravaStrana);

private:
    string jehoJmeno;
    int jehoVek;
};

Student::Student()
: jehoJmeno("Novy student"), jehoVek(16)
{}

Student::Student(const string& jmeno, const int vek)
: jehoJmeno(jmeno), jehoVek(vek)
{}

Student::Student(const Student& pravaStrana)
: jehoJmeno(pravaStrana.ZjistitJmeno()), jehoVek(pravaStrana.ZjistitVek())
{}

Student::~Student()
{}

void Student::ZadatJmeno(const string& jmeno)
{
    jehoJmeno = jmeno;
}

string Student::ZjistitJmeno() const
{
    return jehoJmeno;
}

void Student::ZadatVek(const int vek)
{
    jehoVek = vek;
}

int Student::ZjistitVek() const
{
    return jehoVek;
}

Student& Student::operator=(const Student& pravaStrana)
{
    jehoJmeno = pravaStrana.ZjistitJmeno();
    jehoVek = pravaStrana.ZjistitVek();
    return *this;
}

ostream& operator<<(ostream& os, const Student& pravaStrana)
{
    os << pravaStrana.ZjistitJmeno() << " ma " << pravaStrana.ZjistitVek(); 
    os << " let";
    return os;
}

template<class T, class A>
void ZobrazitMapu(const map<T, A>& v);    // Zobrazen vlastnost mapy

typedef map<string, Student>    Prednaska;

int main()
{
    Student Harry("Harry", 18);
    Student Sally("Sally", 15);
    Student Bill("Bill", 17);
    Student Peter("Peter", 16);

    Prednaska    Matematika;
    Matematika[Harry.ZjistitJmeno()] = Harry;
    Matematika[Sally.ZjistitJmeno()] = Sally;
    Matematika[Bill.ZjistitJmeno()] = Bill;
    Matematika[Peter.ZjistitJmeno()] = Peter;

    cout << "Matematika:\n";
    ZobrazitMapu(Matematika);

    cout << "Vime, ze " << Matematika["Bill"].ZjistitJmeno()
         << " ma " << Matematika["Bill"].ZjistitVek() << " roku\n";

    return 0;
}

//
// Zobrazen vlastnost mapy
//
template<class T, class A>
void ZobrazitMapu(const map<T, A>& v)
{
    for (map<T, A>::const_iterator ci = v.begin();
                    ci != v.end(); ++ci)
        cout << ci->first << ": " << ci->second << "\n";

    cout << endl;
}
