#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

class Pole
{
public:
	// konstruktory
	Pole(int velikostPole = VychoziVelikost);
	Pole(const Pole &ptr);
	~Pole() { delete [] pTyp;}

	// opertory
	Pole& operator=(const Pole&);
	int& operator[](int odskok);
	const int& operator[](int odskok) const;

	// pstupov metody
	int ZiskejVelikostPole() const { return velikostPole; }

	// funkce typu "friend"
	friend ostream& operator<< (ostream&, const Pole&);

	class xHranice {};  // definice tdy vjimky

private:
	int *pTyp;
	int  velikostPole;
};


Pole::Pole(int velikost):
	velikostPole(velikost)
{
	pTyp = new int[velikost];
	for (int i = 0; i<velikost; i++)
		pTyp[i] = 0;
}


Pole& Pole::operator=(const Pole &ptr)
{
	if (this == &ptr)
		return *this;
	delete [] pTyp;
	velikostPole = ptr.ZiskejVelikostPole();
	pTyp = new int[velikostPole];
	for (int i = 0; i<velikostPole; i++)
		pTyp[i] = ptr[i];
	return *this;
}

Pole::Pole(const Pole &ptr)
{
	velikostPole = ptr.ZiskejVelikostPole();
	pTyp = new int[velikostPole];
	for (int i = 0; i<velikostPole; i++)
		pTyp[i] = ptr[i];
}


int& Pole::operator[](int odskok)
{
	int velikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0]; // MSC tento dek vyaduje
}


const int& Pole::operator[](int odskok) const
{
	int mVelikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0]; // MSC tento dek vyaduje
}

ostream& operator<< (ostream& output, const Pole& toPole)
{
	for (int i = 0; i<toPole.ZiskejVelikostPole(); i++)
		output << "[" << i << "] " << toPole[i] << endl;
	return output;
}

int main()
{
	Pole intPole(20);
	try
	{
		for (int j = 0; j< 100; j++)
		{
			intPole[j] = j;
			cout << "intPole[" << j << "] OK..." << endl;
		}
	}
	catch (Pole::xHranice)
	{
		cout << "Neni mozne zpracovat vstup!\n";
	}
	cout << "Hotovo.\n";
	return 0;
}