#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

class Pole
{
public:
	// konstruktory
	Pole(int velikostPole = VychoziVelikost);
	Pole(const Pole &ptr);
	~Pole() { delete [] pTyp;}

	// opertory
	Pole& operator=(const Pole&);
	int& operator[](int odskok);
	const int& operator[](int odskok) const;

	// pstupov metody
	int ZiskejVelikostPole() const { return velikostPole; }

	// funkce typu "friend"
	friend ostream& operator<< (ostream&, const Pole&);

	// definice td pro vjimky
	class xHranice {};
	class xPrilisVelke {};
	class xPrilisMale {};
	class xNulove {};
	class xZaporne {};

private:
	int *pTyp;
	int  velikostPole;
};

int& Pole::operator[](int odskok)
{
	int velikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0]; // MSC tento dek vyaduje
}


const int& Pole::operator[](int odskok) const
{
	int mVelikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0]; // MSC tento dek vyaduje
}


Pole::Pole(int velikost):
	velikostPole(velikost)
{
	if (velikost == 0)
		throw xNulove();
	if (velikost < 10)
		throw xPrilisMale();
	if (velikost > 30000)
		throw xPrilisVelke();
	if (velikost < 1)
		throw xZaporne();

	pTyp = new int[velikost];
	for (int i = 0; i<velikost; i++)
		pTyp[i] = 0;
}

int main()
{
	try
	{
		Pole intPole(0);
		for (int j = 0; j< 100; j++)
		{
			intPole[j] = j;
			cout << "intPole[" << j << "] OK...\n";
		}
	}
	catch (Pole::xHranice)
	{
		cout << "Neni mozne zpracovat vstup!\n";
	}
	catch (Pole::xPrilisVelke)
	{
		cout << "Toto pole je prilis velke...\n";
	}
	catch (Pole::xPrilisMale)
	{
		cout << "Toto pole je prilis male...\n";
	}
	catch (Pole::xNulove)
	{
		cout << "Snazili jste se vytvorit pole";
		cout << "s nulovym poctem objektu!\n";
	}
	catch (...)
	{
		cout << "Neco se pokazilo!\n";
	}
	cout << "Hotovo.\n";
	return 0;
}