#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

class Pole
{
public:
	// konstruktory
	Pole(int velikostPole = VychoziVelikost);
	Pole(const Pole &ptr);
	~Pole() { delete [] pTyp;}

	// opertory
	Pole& operator=(const Pole&);
	int& operator[](int odskok);
	const int& operator[](int odskok) const;

	// pstupov metody
	int ZiskejVelikostPole() const { return velikostPole; }

	// funkce typu "friend"
	friend ostream& operator<< (ostream&, const Pole&);

	// definice td pro vjimky
	class xHranice {};
	class xVelikost
	{
	public:
		xVelikost(int velikost):velikostPole(velikost) {}
		~xVelikost(){}
		int ZiskejVelikost() { return velikostPole; }
	private:
		int velikostPole;
	};

	class xPrilisVelke : public xVelikost
	{
	public:
		xPrilisVelke(int velikost):xVelikost(velikost){}
	};

	class xPrilisMale : public xVelikost
	{
	public:
		xPrilisMale(int velikost):xVelikost(velikost){}
	};

	class xNulove : public xPrilisMale
	{
	public:
		xNulove(int velikost):xPrilisMale(velikost){}
	};

	class xZaporne : public xVelikost
	{
	public:
		xZaporne(int velikost):xVelikost(velikost){}
	};

private:
	int *pTyp;
	int  velikostPole;
};


Pole::Pole(int velikost):
	velikostPole(velikost)
{
	if (velikost == 0)
		throw xNulove(velikost);
	if (velikost > 30000)
		throw xPrilisVelke(velikost);
	if (velikost < 1)
		throw xZaporne(velikost);
	if (velikost < 10)
		throw xPrilisMale(velikost);

	pTyp = new int[velikost];
	for (int i = 0; i<velikost; i++)
		pTyp[i] = 0;
}

int& Pole::operator[](int odskok)
{
	int velikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}


const int& Pole::operator[](int odskok) const
{
	int mVelikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}

int main()
{
	try
	{
		Pole intPole(9);
		for (int j = 0; j< 100; j++)
		{
			intPole[j] = j;
			cout << "intPole[" << j << "] OK...\n";
		}
	}
	catch (Pole::xHranice)
	{
		cout << "Neni mozne zpracovat vstup!\n";
	}
	catch (Pole::xNulove vyjimka)
	{
		cout << "Snazili jste se vytvorit pole s nulovym poctem objektu!\n";
		cout << "Obdrzeny pocet: " << vyjimka.ZiskejVelikost() << endl;
	}
	catch (Pole::xPrilisVelke vyjimka)
	{
		cout << "Toto pole je prilis velke...\n";
		cout << "Obdrzeny pocet: " << vyjimka.ZiskejVelikost() << endl;
	}
	catch (Pole::xPrilisMale vyjimka)
	{
		cout << "Toto pole je prilis male...\n";
		cout << "Obdrzeny pocet: " << vyjimka.ZiskejVelikost() << endl;
	}
	catch (...)
	{
		cout << "Neco se pokazilo, ale nemam poneti, co!\n";
	}
	cout << "Hotovo.\n";
	return 0;
}