#include <iostream>
using namespace std;

const int VychoziVelikost = 10;

class Pole
{
public:
	// konstruktory
	Pole(int velikostPole = VychoziVelikost);
	Pole(const Pole &ptr);
	~Pole() { delete [] pTyp;}

	// opertory
	Pole& operator=(const Pole&);
	int& operator[](int odskok);
	const int& operator[](int odskok) const;

	// pstupov metody
	int ZiskejVelikostPole() const { return velikostPole; }

	// funkce typu "friend"
	friend ostream& operator<< (ostream&, const Pole&);

	// definice td pro vjimky
	class xHranice {};
	class xVelikost
	{
	public:
		xVelikost(int velikost):velikostPole(velikost) {}
		~xVelikost(){}
		virtual int ZiskejVelikost() { return velikostPole; }
		virtual void TiskChyby()
		{
			cout << "Chyba velikosti! Obdrzeny pocet: ";
			cout << velikostPole << endl;
		}
	protected:
		int velikostPole;
	};

	class xPrilisVelke : public xVelikost
	{
	public:
		xPrilisVelke(int velikost):xVelikost(velikost){}
		virtual void TiskChyby()
		{
			cout << "Prilis velke! Obdrzeny pocet: ";
			cout << xVelikost::velikostPole << endl;
		}
	};

	class xPrilisMale : public xVelikost
	{
	public:
		xPrilisMale(int velikost):xVelikost(velikost){}
		virtual void TiskChyby()
		{
			cout << "Prilis male! Obdrzeny pocet: ";
			cout << xVelikost::velikostPole << endl;
		}
	};

	class xNulove : public xPrilisMale
	{
	public:
		xNulove(int velikost):xPrilisMale(velikost){}
		virtual void TiskChyby()
		{
			cout << "Nulove! Obdrzeny pocet: ";
			cout << xVelikost::velikostPole << endl;
		}
	};

	class xZaporne : public xVelikost
	{
	public:
		xZaporne(int velikost):xVelikost(velikost){}
		virtual void TiskChyby()
		{
			cout << "Zaporne! Obdrzeny pocet: ";
			cout << xVelikost::velikostPole << endl;
		}
	};

private:
	int *pTyp;
	int  velikostPole;
};


Pole::Pole(int velikost):
	velikostPole(velikost)
{
	if (velikost == 0)
		throw xNulove(velikost);
	if (velikost > 30000)
		throw xPrilisVelke(velikost);
	if (velikost < 1)
		throw xZaporne(velikost);
	if (velikost < 10)
		throw xPrilisMale(velikost);

	pTyp = new int[velikost];
	for (int i = 0; i<velikost; i++)
		pTyp[i] = 0;
}

int& Pole::operator[](int odskok)
{
	int velikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}


const int& Pole::operator[](int odskok) const
{
	int mVelikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}

int main()
{
	try
	{
		Pole intPole(9);
		for (int j = 0; j< 100; j++)
		{
			intPole[j] = j;
			cout << "intPole[" << j << "] OK...\n";
		}
	}
	catch (Pole::xHranice)
	{
		cout << "Neni mozne zpracovat vstup!\n";
	}
	catch (Pole::xVelikost& vyjimka)
	{
		vyjimka.TiskChyby();
	}
	catch (...)
	{
		cout << "Neco se pokazilo!\n";
	}
	cout << "Hotovo.\n";
	return 0;
}