#include <iostream>
using namespace std;

const int VychoziVelikost = 10;
class xHranice {};

template <class T>
class Pole
{
public:
	// konstruktory
	Pole(int velikostPole = VychoziVelikost);
	Pole(const Pole &ptr);
	~Pole() { delete [] pTyp;}

	// opertory
	Pole& operator=(const Pole<T>&);
	T& operator[](int odskok);
	const T& operator[](int odskok) const;

	// pstupov metody
	int ZiskejVelikostPole() const { return velikostPole; }

	// funkce typu "friend"
	friend ostream& operator<< (ostream&, const Pole<T>&);

	// definice td pro vjimky

	class xVelikost {};

private:
	int *pTyp;
	int  velikostPole;
};

template <class T>
Pole<T>::Pole(int velikost):
	velikostPole(velikost)
{
	if (velikost <10 || velikost > 30000)
		throw xVelikost();
	pTyp = new T[velikost];
	for (int i = 0; i<velikost; i++)
		pTyp[i] = 0;
}

template <class T>
Pole<T>& Pole<T>::operator=(const Pole<T> &ptr)
{
	if (this == &ptr)
		return *this;
	delete [] pTyp;
	velikostPole = ptr.ZiskejVelikostPole();
	pTyp = new T[velikostPole];
	for (int i = 0; i<velikostPole; i++)
		pTyp[i] = ptr[i];
}
template <class T>
Pole<T>::Pole(const Pole<T> &ptr)
{
	velikostPole = ptr.ZiskejVelikostPole();
	pTyp = new T[velikostPole];
	for (int i = 0; i<velikostPole; i++)
		pTyp[i] = ptr[i];
}

template <class T>
T& Pole<T>::operator[](int odskok)
{
	int velikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}

template <class T>
const T& Pole<T>::operator[](int odskok) const
{
	int mVelikost = ZiskejVelikostPole();
	if (odskok >= 0 && odskok < ZiskejVelikostPole())
		return pTyp[odskok];
	throw xHranice();
	return pTyp[0];
}

template <class T>
ostream& operator<< (ostream& vystup, const Pole<T>& toPole)
{
	for (int i = 0; i<toPole.ZiskejVelikostPole(); i++)
		vystup << "[" << i << "] " << toPole[i] << endl;
	return vystup;
}


int main()
{
	try
	{
		Pole<int> intPole(9);
		for (int j = 0; j< 100; j++)
		{
			intPole[j] = j;
			cout << "intPole[" << j << "] OK...\n";
		}
	}
	catch (xHranice)
	{
		cout << "Neni mozne zpracovat vstup!\n";
	}
	catch (Pole<int>::xVelikost)
	{
		cout << "Spatna velikost!\n";
	}

	cout << "Hotovo.\n";
	return 0;
}