#include <iostream>
using namespace std;
enum VOLBA { KresliObd = 1, SpoctiObsah, SpoctiObvod,
   ZmenRozmery, Konec };

// Deklarace tdy Obdlnk
class Obdelnik
{
   public:
      // konstruktory
      Obdelnik(int sirka, int vyska);
      ~Obdelnik();

      // pstupov funkce
      int ZiskejVysku() const { return vyskaObd; }
      int ZiskejSirku() const { return sirkaObd; }
      int SpoctiObsah() const { return vyskaObd * sirkaObd; }
      int SpoctiObvod() const { return 2*vyskaObd + 2*sirkaObd; }
      void NastavVelikost(int novaSirka, int novaVyska);

      // Rzn metody


   private:
      int sirkaObd;
      int vyskaObd;
};

// Implementace metod tdy
void Obdelnik::NastavVelikost(int novaSirka, int novaVyska)
{
   sirkaObd = novaSirka;
   vyskaObd = novaVyska;
}


Obdelnik::Obdelnik(int sirka, int vyska)
{
   sirkaObd = sirka;
   vyskaObd = vyska;
}

Obdelnik::~Obdelnik() {}

int Nabidka();
void KresbaObd(Obdelnik);
void VypocetObsahu(Obdelnik);
void VypocetObvodu(Obdelnik);

int main ()
{
   // inicializace obdlnka na 30, 5
   Obdelnik obd(30,5);

   int volba = KresliObd;
   int fKonec = false;

   while (!fKonec)
   {
      volba = Nabidka();
      if (volba < KresliObd || volba > Konec)
      {
         cout << "\nNeplatna volba, zkuste prosim znovu.\n\n";
         continue;
      }
      switch (volba)
      {
      case KresliObd:
         KresbaObd(obd);
         break;
      case SpoctiObsah:
         VypocetObsahu(obd);
         break;
      case SpoctiObvod:
         VypocetObvodu(obd);
         break;
      case ZmenRozmery:
         int novaDelka, novaSirka;
         cout << "\nNova sirka: ";
         cin >> novaSirka;
         cout << "Nova vyska: ";
         cin >> novaDelka;
         obd.NastavVelikost(novaSirka, novaDelka);
         KresbaObd(obd);
         break;
      case Konec:
         fKonec = true;
         cout << "\nUkonceni programu...\n\n";
         break;
      default:
         cout << "Chybna volba!\n";
         fKonec = true;
         break;
      }   // konec switch
   }      // konec while
   return 0;
}         // konec main

int Nabidka()
{
   int volba;
   cout << "\n\n   *** Nabidka *** \n";
   cout << "(1) Kresba Obdelnika\n";
   cout << "(2) Obsah\n";
   cout << "(3) Obvod\n";
   cout << "(4) Zmena rozmeru\n";
   cout << "(5) Konec\n";

   cin >> volba;
   return volba;
}

void KresbaObd(Obdelnik obd)
{
   int vyska = obd.ZiskejVysku();
   int sirka = obd.ZiskejSirku();

   for (int i = 0; i<vyska; i++)
   {
      for (int j = 0; j<sirka; j++)
         cout << "*";
      cout << "\n";
   }
}


void VypocetObsahu(Obdelnik obd)
{
   cout << "Obsah: " << obd.SpoctiObsah() << endl;
}

void VypocetObvodu(Obdelnik obd)
{
   cout << "Obvod: " << obd.SpoctiObvod() << endl;
}